import QtQuick 2.3
import QtQuick.Controls 1.2
import QtQuick.Layouts 1.1
import Tune 1.0

ColumnLayout {
    spacing: 5
    visible: abclistview.model.count > 0
    id: abclistArea
    property alias tune: abctext.tune
    states: [
        State {
            name: "open"
            PropertyChanges { target: abclistview; visible: true }
            //PropertyChanges { target: dropDescription; text: "Hide ABC text for tune" }
            //PropertyChanges { target: abceditbutton; visible: true }
            //PropertyChanges { target: abceditbutton; text: "Edit..." }
            //PropertyChanges { target: abcrevertbutton; visible: abctext.tune.canRevert }
            //PropertyChanges { target: adctoolbar; visible: true }
        },
        State {
            name: "editing"
            PropertyChanges { target: abctext; visible: true }
            PropertyChanges { target: abctext; text: getAbcText(); }
            //PropertyChanges { target: abceditbutton; visible: true }
            //PropertyChanges { target: abceditbutton; text: "Save" }
            //PropertyChanges { target: abccancelbutton; visible: true }
            //PropertyChanges { target: adctoolbar; visible: true }
        }

    ]
    Rectangle {
        //width: 70
        id: abcbar
        Layout.fillWidth: true
        //width: parent.fillWidth
        //height: 40 * mainview.scale
        height: settings.actionbarHeight
        color: settings.actionbarColor
        RowLayout {
            spacing: 50
            anchors.fill: parent
            Rectangle {
                //height: parent.height
                //color: "green"
                width: 1
                Layout.alignment: Qt.AlignLeft
            }
//            Rectangle {
//                height: settings.actionbarHeight
//                width: settings.actionbarHeight
//                Layout.alignment: Qt.AlignLeft
//                //color: "green"
//                settings.actionbarColor
//                Text {
//                    anchors.centerIn: parent
//                    text: "^"
//                }
//                MouseArea {
//                    anchors.fill: parent
//                    onClicked: {
//                        if (tuneview.state === "")
//                            tuneview.state = "infohidden";
//                        else
//                            tuneview.state = "";
//                    }
//                }
//            }
            Text {
                id: dropDescription
                Layout.alignment: Qt.AlignLeft
                //anchors.centerIn: parent
                text: {
                    "ABC encoding"
                }
                color: abclistArea.state === "" ? "black" : "red"
                font.pixelSize: Math.floor(12 * settings.list_scale)
                Rectangle {
                    height: settings.actionbarHeight    //abclistArea.height
                    width: parent.width + 10
                    anchors.centerIn: parent
                    radius: settings.buttonRadius
                    opacity: settings.buttonOpacity
                    color: settings.buttonColor
                    MouseArea {
                       anchors.fill: parent
                       onClicked: {
                           if (abclistArea.state === "open" || abclistArea.state === "editing")
                               abclistArea.state = "";
                           else
                               abclistArea.state = "open";
                        }
                    }
                }
            }
            // spacer
            Rectangle {
                //height: parent.height
                id: spacer
                color: settings.actionbarColor
                height: settings.actionbarHeight
                Layout.fillWidth: true
                Layout.alignment: Qt.AlignLeft
                Rectangle {
                    color: parent.color
                    height: parent.height
                    width: spacer.width / 3
                    anchors.centerIn: parent
//                    ColumnLayout {
//                        spacing: 2
//                        anchors.centerIn: parent
//                        height: parent.height * 3 / 4
//                        width: spacer.width / 3
//                        Rectangle {
//                            Layout.fillWidth: true
//                            opacity: settings.actionbarGripperOpacity
//                            color: settings.actionbarGripperColor
//                            height: settings.homeMenuSides
//                        }
//                        Rectangle {
//                            Layout.fillWidth: true
//                            opacity: settings.actionbarGripperOpacity
//                            color: settings.actionbarGripperColor
//                            height: settings.homeMenuSides
//                        }
//                        Rectangle {
//                            Layout.fillWidth: true
//                            opacity: settings.actionbarGripperOpacity
//                            color: settings.actionbarGripperColor
//                            height: settings.homeMenuSides
//                        }
//                    }
                    Rectangle {
                        color: "transparent"    //parent.color
                        anchors.centerIn: parent
                        height: parent.height * 2 / 3
                        width: parent.width //parent.height * 2 / 3
                        Canvas {
                            id: drawing
                            Component.onCompleted: requestPaint()
                            anchors.fill: parent
                            onPaint: {
                                var ctx = getContext('2d');
                                ctx.clearRect(0, 0, width, height);
                                ctx.beginPath();
                                ctx.globalAlpha = 0.5;
                                ctx.lineWidth = 1;
                                //ctx.strokeStyle = "gray";
                                ctx.fillStyle = "gray";
                                if (tuneview.state !== "") {
                                    ctx.moveTo(0,0);
                                    ctx.lineTo(width / 2, height);
                                    ctx.lineTo(width, 0);
                                }
                                else {
                                    ctx.moveTo(0, height);
                                    ctx.lineTo(width / 2, 0);
                                    ctx.lineTo(width, height);
                                }
                                //ctx.stroke();
                                ctx.fill();
                            }

                        }

//                        Image {
//                            anchors.fill: parent
//                            source: tuneview.state === "" ? "arrow-up.png" : "arrow-down.png"
//                        }
                    }
                    MouseArea {
                        anchors.fill: parent
                        onClicked: {
                            if (tuneview.state === "")
                                tuneview.state = "infohidden";
                            else
                                tuneview.state = "";
                            drawing.requestPaint();
                            tuneview.redrawScore(tuneview.currentTune);
                        }
                    }
                }
            }
            // staff view
            Text {
                id: stafftext
                visible: score.guitarTabIsSet() || score.mandolinTabIsSet()
                Layout.alignment: Qt.AlignRight
                text: "Staff view"
                color: score.hideStaffViewOnTabIsSet() ? "black" : "red"
                font.pixelSize: Math.floor(12 * settings.list_scale)
                 //font.pixelSize: Math.floor(12 * mainview.text_scale)
                 //font.italic: true
                Rectangle {
                    height: settings.actionbarHeight    //abclistArea.height
                    width: parent.width + 10
                    anchors.centerIn: parent
                    radius: settings.buttonRadius
                    opacity: settings.buttonOpacity
                    color: settings.buttonColor
                     MouseArea {
                        anchors.fill: parent
                        onClicked: {
                            tunebook.toggleHideStaffViewOnTab();
                            // color doesn't update for some reason
                            stafftext.color = score.hideStaffViewOnTabIsSet() ? "black" : "red";
                        }
                     }
                }
            }
            RowLayout {
                // guitar
                Text {
                    Layout.alignment: Qt.AlignRight
                    text: "Guitar tab"
                    color: score.guitarTabIsSet() ? "red" : "black"
                    font.pixelSize: Math.floor(12 * settings.list_scale)
                     //font.pixelSize: Math.floor(12 * mainview.text_scale)
                     //font.italic: true
                    Rectangle {
                        height: settings.actionbarHeight    //abclistArea.height
                        width: parent.width + 10
                        anchors.centerIn: parent
                        radius: settings.buttonRadius
                        opacity: settings.buttonOpacity
                        color: settings.buttonColor
                         MouseArea {
                            anchors.fill: parent
                            onClicked: {
                                if (score.guitarTabIsSet())
                                     score.setNoTab();
                                 else
                                    score.setGuitarTab();
                            }
                         }
                    }
                }
                Text {
                    id: guitarlegstext
                    visible: score.guitarTabIsSet()
                    Layout.alignment: Qt.AlignRight
                    text: "+ timing marks"
                    color: score.showLegsIsSet() ? "red" : "black"
                    font.pixelSize: Math.floor(12 * settings.list_scale)
                     //font.pixelSize: Math.floor(12 * mainview.text_scale)
                     //font.italic: true
                    Rectangle {
                        height: settings.actionbarHeight    //abclistArea.height
                        width: parent.width + 10
                        anchors.centerIn: parent
                        radius: settings.buttonRadius
                        opacity: settings.buttonOpacity
                        color: settings.buttonColor
                         MouseArea {
                            anchors.fill: parent
                            onClicked: {
                                tunebook.toggleShowLegs();
                                // color doesn't update for some reason
                                mandolinlegstext.color = score.showLegsIsSet() ? "red" : "black";
                                guitarlegstext.color = score.showLegsIsSet() ? "red" : "black";
                            }
                         }
                    }
                }
            }
            RowLayout {
                // mandolin
                Text {
                    Layout.alignment: Qt.AlignRight
                    color: score.mandolinTabIsSet() ? "red" : "black"
                    text: "Mandolin tab"
                    font.pixelSize: Math.floor(12 * settings.list_scale)
                    //font.pixelSize: Math.floor(12 * mainview.text_scale)
                    //font.italic: true
                    Rectangle {
                        height: settings.actionbarHeight   //abclistArea.height
                        width: parent.width + 10
                        anchors.centerIn: parent
                        radius: settings.buttonRadius
                        opacity: settings.buttonOpacity
                        color: settings.buttonColor
                        MouseArea {
                            anchors.fill: parent
                            onClicked: {
                                if (score.mandolinTabIsSet())
                                    score.setNoTab();
                                else
                                    score.setMandolinTab();
                            }
                        }
                    }
                }
                Text {
                    id: mandolinlegstext
                    visible: score.mandolinTabIsSet()
                    Layout.alignment: Qt.AlignRight
                    text: "+ timing marks"
                    color: score.showLegsIsSet() ? "red" : "black"
                    font.pixelSize: Math.floor(12 * settings.list_scale)
                     //font.pixelSize: Math.floor(12 * mainview.text_scale)
                     //font.italic: true
                    Rectangle {
                        height: settings.actionbarHeight    //abclistArea.height
                        width: parent.width + 10
                        anchors.centerIn: parent
                        radius: settings.buttonRadius
                        opacity: settings.buttonOpacity
                        color: settings.buttonColor
                         MouseArea {
                            anchors.fill: parent
                            onClicked: {
                                tunebook.toggleShowLegs();
                                // color doesn't update for some reason
                                mandolinlegstext.color = score.showLegsIsSet() ? "red" : "black";
                                guitarlegstext.color = score.showLegsIsSet() ? "red" : "black";
                            }
                         }
                    }
                }
            }
            Text {
                visible: false
                Layout.alignment: Qt.AlignRight
                text: "Share"
                font.pixelSize: Math.floor(12 * settings.list_scale)
                Rectangle {
                    height: settings.actionbarHeight   //abclistArea.height
                    width: parent.width + 10
                    anchors.centerIn: parent
                    radius: settings.buttonRadius
                    opacity: settings.buttonOpacity
                    color: settings.buttonColor
                    MouseArea {
                        anchors.fill: parent
                        onClicked: {
                            tuneview.currentTune.share();
                        }
                    }
                }
            }
             Rectangle {
                 //height: parent.height
                 //color: "green"
                 width: 1
                 Layout.alignment: Qt.AlignRight
             }
        }
    }
    TextArea {
        id: abctext
        Layout.fillWidth: true
        Layout.preferredHeight: lineCount * 18 * mainview.score_scale
        property Tune tune
        //height: 150 * mainview.scale
        visible: false
        wrapMode: TextEdit.NoWrap
        font.pixelSize: Math.floor(12 * mainview.score_scale)
        function getAbcText()
        {
            return tunes.populateAbcLineText(tune);
        }
        function save() {
            selectAll();
            tunes.updateAbc(selectedText, tune);
            text = "";
        }
    }
    ListView {
        id: abclistview
        Layout.preferredHeight: contentHeight
        visible: false
        property int itemHeight: 20 * mainview.score_scale
        model: abcLinesListModel;   // tune.getAbcModel()
        delegate :
            Text {
                id: abcline
                //width: 200
                //height: abclistview.itemHeight
                //font.pixelSize: Math.floor(12 * mainview.score_scale)
                font.pixelSize: Math.floor(6 * settings.text_scale / settings.iosScale)
                textFormat: Text.PlainText
                text: content
            }
    }
    /*ToolBar {
        id: adctoolbar
        visible: false
        RowLayout {
            ToolButton {
                id: abceditbutton
                visible: false
                text: "Edit"
                onClicked: {
                    if (abclistArea.state === "open")
                        abclistArea.state = "editing";
                    else if (abclistArea.state === "editing")
                    {
                        abctext.save();
                        abclistArea.state = "open";
                    }
                    else
                        abclistArea.state = "open";
                }
            }
            ToolButton {
                id: abccancelbutton
                visible: false
                text: "Cancel"
                onClicked: {
                        abclistArea.state = "open";
                }
            }
            ToolButton {
                id: abcrevertbutton
                visible: false
                text: "Revert"
                onClicked: {
                    tunes.revertAbc(abctext.tune);
                }
            }
        }
    }*/

    /*Row {
        spacing: 20
        Button {
            id: abceditbutton
            visible: false
            onClicked: {
                if (abclistArea.state === "open")
                    abclistArea.state = "editing";
                else if (abclistArea.state === "editing")
                {
                    abctext.save();
                    abclistArea.state = "open";
                }
                else
                    abclistArea.state = "open";
            }
        }
        Button {
            id: abccancelbutton
            visible: false
            text: "Cancel"
            onClicked: {
                    abclistArea.state = "open";
            }
        }
        Button {
            id: abcrevertbutton
            visible: false
            text: "Revert"
            onClicked: {
                tunes.revertAbc(abctext.tune);
            }
        }
    }*/
}
