import QtQuick 2.3
import QtQuick.Controls 1.2
import QtQuick.Controls.Styles 1.2
import QtQuick.Layouts 1.1

Rectangle {
    property alias searchInputFocus: searchinput.focus
    property alias favourites: favourites
    property alias session: session
    property alias actionbarTempoText: actionbarTempoText
    property alias actionbarChordText : actionbarChordText
    property alias actionbarMelodyText: actionbarMelodyText
    property alias actionbarRhythmsText: actionbarRhythmsText
    width: parent.width
    height: settings.actionbarHeight
    color: "light grey"
    RowLayout {
        anchors.fill: parent
        spacing: settings.actionbarSpacing
        Rectangle {
            Layout.alignment: Qt.AlignLeft
            Layout.fillHeight: true
            color: "red"
            Layout.preferredWidth: settings.actionbarHeight
            ColumnLayout {
                spacing: 2
                anchors.centerIn: parent
                height: parent.height * 3 / 4
                Rectangle {
                    color: actionbar.color
                    width: settings.homeMenuSides * 5
                    height: settings.homeMenuSides
                }
                Rectangle {
                    color: actionbar.color
                    width: settings.homeMenuSides * 5
                    height: settings.homeMenuSides
                }
                Rectangle {
                    color: actionbar.color
                    width: settings.homeMenuSides * 5
                    height: settings.homeMenuSides
                }
            }
//            Image {
//                source: "home.png"
//                anchors.centerIn: parent
//                height: parent.height / 1.2
//                width: height
//            }

//            Text {
//                anchors.centerIn: parent
//                color: "white"
//                text: "<"
//            }

            //width:50
            //height: settings.actionbarHeight
            MouseArea {
                // back to the library
                anchors.fill: parent
                onClicked: {
                    //tunebook.visible = false;
                    //booklist.visible = true;
                    mainview.state = "visible";
                    //bookloader.source = "";
                }
            }
        }
        Text {
            visible: !searchbox.visible
            Layout.alignment: Qt.AlignLeft
            //Layout.fillHeight: true
            id: actionbarRhythmsText
            text: {
                if (tunes.tunesItem == null)
                    return "";
                else {
                    var name = tunes.tunesItem.getRhythmModel().getName(rhythmsContainer.index);
                    if (name.indexOf("Group: ") === 0)
                        return name;
                    return "Rhythm: " + name;
                }
            }
            font.pixelSize: Math.floor(12 * settings.list_scale)
            Rectangle {
                height: actionbar.height
                width: parent.width
                anchors.centerIn: parent
                opacity: settings.buttonOpacity
                color: settings.buttonColor
                radius: settings.buttonRadius
                MouseArea {
                    anchors.fill: parent
                    onClicked: {
                        if (rhythmsContainer.state === "open")
                            rhythmsContainer.state = "";
                        else
                        {
                            closeAllMenus();
                            rhythmsContainer.state = "open";
                        }
                    }
                }
            }
        }
        Text {
            visible: settings.supportsAudio
            Layout.alignment: Qt.AlignLeft
            //Layout.fillHeight: true
            id: actionbarMelodyText
            text: {
                tunes.tunesItem ?
                   "Melody: " + instrumentlistmodel.getName(tunes.tunesItem.melodyInstrument)
                   : "";
            }
            font.pixelSize: Math.floor(12 * settings.list_scale)
            Rectangle {
                height: actionbar.height
                width: parent.width
                anchors.centerIn: parent
                opacity: settings.buttonOpacity
                color: settings.buttonColor
                radius: settings.buttonRadius
                MouseArea {
                    anchors.fill: parent
                    onClicked: {
                        if (melodyinstrumentsContainer.state === "open")
                            melodyinstrumentsContainer.state = "";
                        else
                        {
                            closeAllMenus();
                            melodyinstrumentsContainer.state = "open";
                        }
                    }
                }
            }
        }
        Text {
            visible: settings.supportsAudio
            Layout.alignment: Qt.AlignLeft
            //Layout.fillHeight: true
            id: actionbarChordText
            text: {
                tunes.tunesItem ?
                   "Chords: " + instrumentlistmodel.getName(tunes.tunesItem.chordInstrument)
                   : "";
            }
            font.pixelSize: Math.floor(12 * settings.list_scale)
            Rectangle {
                height: actionbar.height
                width: parent.width
                anchors.centerIn: parent
                opacity: settings.buttonOpacity
                color: settings.buttonColor
                radius: settings.buttonRadius
                MouseArea {
                    anchors.fill: parent
                    onClicked: {
                        if (chordinstrumentsContainer.state === "open")
                            chordinstrumentsContainer.state = "";
                        else
                        {
                            closeAllMenus();
                            chordinstrumentsContainer.state = "open";
                        }
                    }
                }
            }
        }
        Text {
            visible: settings.supportsAudio
            Layout.alignment: Qt.AlignLeft
            //Layout.fillHeight: true
            id: actionbarTempoText
            text: {
                tunearea.currentTune ?
                   "Tempo: " + tunearea.currentTune.tempo
                   : "";
            }
            font.pixelSize: Math.floor(12 * settings.list_scale)
            Rectangle {
                height: actionbar.height
                width: parent.width
                anchors.centerIn: parent
                opacity: settings.buttonOpacity
                color: settings.buttonColor
                radius: settings.buttonRadius
                MouseArea {
                    anchors.fill: parent
                    onClicked: {
                        if (tempolistContainer.state === "open")
                            tempolistContainer.state = "";
                        else
                        {
                            closeAllMenus();
                            tempolistContainer.state = "open";
                        }
                    }
                }
            }
        }
        RowLayout {
            Layout.alignment: Qt.AlignLeft
            Layout.fillHeight: true
            visible: tunearea.currentTune !== null
            spacing: 10
            Rectangle {
                Layout.alignment: Qt.AlignRight
                Layout.fillHeight: true
                Layout.preferredWidth: settings.actionbarHeight
                //anchors.centerIn: parent
                //opacity: settings.buttonOpacity
                color: actionbar.color  // settings.buttonColor
                radius: settings.buttonRadius
                border.width: settings.buttonBorderWidth
                border.color: "gray"
                //height: settings.actionbarHeight
                //width: settings.actionbarHeight
                //color: actionbar.color
                Image { // DOWN arror
                    anchors.centerIn: parent
                    width: parent.height / 2
                    height: parent.height / 2
                    source: "arrow-down.png"
                    fillMode: Image.Stretch
                }
                MouseArea {
                    anchors.fill: parent
                    onClicked: {
                        tunearea.currentTune.decrementKey();
                        tunearea.redrawScore(tunearea.currentTune);
                    }
                }
            }
            Text {
                Layout.alignment: Qt.AlignCenter
                //Layout.fillHeight: true
                text: {
                    //tunearea.currentTune ? "Key: " + tunearea.currentTune.adjustedKey : "";
                    tunearea.currentTune ? tunearea.currentTune.adjustedKey : "";
                }
                font.pixelSize: Math.floor(12 * settings.list_scale)
            }
            Rectangle {
                Layout.alignment: Qt.AlignLeft
                Layout.fillHeight: true
                Layout.preferredWidth: settings.actionbarHeight
                //height: settings.actionbarHeight
                //width: settings.actionbarHeight
                //anchors.centerIn: parent
                //opacity: settings.buttonOpacity
                //color: settings.buttonColor
                //radius: settings.buttonRadius
                //color: actionbar.color
                //opacity: settings.buttonOpacity
                color: actionbar.color  // settings.buttonColor
                radius: settings.buttonRadius
                border.width: settings.buttonBorderWidth
                border.color: "gray"
                Image { // UP arrow
                    anchors.centerIn: parent
                    width: parent.height / 2
                    height: parent.height / 2
                    source: "arrow-up.png"
                    fillMode: Image.Stretch
                }
                MouseArea {
                    anchors.fill: parent
                    onClicked: {
                        tunearea.currentTune.incrementKey();
                        tunearea.redrawScore(tunearea.currentTune);
                    }
                }
            }
        }
        Rectangle {
            Layout.fillWidth: true
        }
        GroupSelector {
            id: session
            Layout.alignment: Qt.AlignRight
            text: "Session"
            property string groupName: "Session"
            property string extendedGroupName: "Group: Session"
            function isInOurGroup(groupname, title) {
                if (groupname === extendedGroupName)
                    return isInGroup(title);
                return false;
            }
            function loadGroup(book) {
                load(book);
            }
        }
        GroupSelector {
            Layout.alignment: Qt.AlignRight
            id: favourites
            text: "Favourite"
            property string groupName: "Favourite"
            property string extendedGroupName: "Group: Favourites"
            function isInOurGroup(groupname, title) {
                if (groupname === extendedGroupName)
                    return isInGroup(title);
                return false;
            }
            function loadGroup(book) {
                load(book);
            }
        }
        Rectangle {
            id: searchbox
            visible: false
            Layout.alignment: Qt.AlignRight
            Layout.fillHeight: true
            color: actionbar.color
            Layout.preferredWidth: 200
            //height: parent.height
            Rectangle {
                anchors.centerIn: parent
                width: parent.width
                height: parent.height * .8
                radius: 10 * settings.iosScale
                color: "white"
                RowLayout {
                    anchors.fill: parent
                    TextInput {
                        Layout.fillWidth: true
                        //Layout.fillHeight: true
                        id: searchinput
                        onTextChanged: tunes.populateTunesListFromSearch(text);
                        onFocusChanged: {
                            if (focus) {
                                Qt.inputMethod.show();
                            }
                            else {
                                Qt.inputMethod.hide();
                            }
                        }
                    }
                    Rectangle {
                        Layout.alignment: Qt.AlignRight
                        width: actionbar.height * 0.7
                        height: actionbar.height * 0.7
                        //opacity: settings.buttonOpacity
                        color: actionbar.color  // settings.buttonColor
                        radius: settings.buttonRadius
                        border.width: settings.buttonBorderWidth
                        border.color: "gray"
                        Image {
                            Layout.alignment: Qt.AlignRight
                            anchors.fill: parent
                            //width: actionbar.height / 2
                            //height: actionbar.height / 2
                            source: "icon-clear.png"
                            fillMode: Image.Stretch
                            MouseArea {
                                anchors.fill: parent
                                onClicked: {
                                    // hide search box
                                    searchicon.visible = true;
                                    searchbox.visible = false;
                                    tunes.populateTunesListFromSearch("");
                                    searchinput.focus = false;
                                    searchinput.text = "";
                                    //console.log("hiding keyboard");
                                    //Qt.inputMethod.hide();
                                }
                            }
                        }
                    }
                }
            }
        }
        Rectangle {
            visible: tunes.tunesItem !== null
            id: searchicon
            Layout.alignment: Qt.AlignRight
            Layout.fillHeight: true
            Layout.preferredWidth: settings.actionbarHeight
            //color: actionbar.color
            //opacity: settings.buttonOpacity
            color: actionbar.color  // settings.buttonColor
            radius: settings.buttonRadius
            border.width: settings.buttonBorderWidth
            border.color: "gray"
            //Layout.preferredWidth: 50
            //width:50
            //height: parent.height
            MouseArea {
                anchors.fill: parent
                onClicked: {
                    // show search box
                    searchicon.visible = false;
                    searchbox.visible = true;
                    //searchinput.text = tunes.lastSearchText;
                    if (searchinput.text !== "")
                        tunes.populateTunesListFromSearch(searchinput.text);
                    searchinput.focus = true;
                }
            }
            Image {
                anchors.centerIn: parent
                width: parent.width / 2
                height: parent.height / 2
                source: "icon-search.png"
                fillMode: Image.Stretch
            }
        }

        Rectangle {
            visible: settings.supportsAudio
            id: settingsmenubutton
            Layout.alignment: Qt.AlignRight
            color: actionbar.color
            Layout.preferredWidth: 50
            //width:50
            height: parent.height
            MouseArea {
                anchors.fill: parent
                onClicked: {
                    threedotsmenu.settingsmenu.popup();
                }
            }
            ColumnLayout {
                spacing: 2
                anchors.centerIn: parent
                height: parent.height * 3 / 4
                Rectangle {
                    color: "white"
                    width: settings.menudotsSides
                    height: settings.menudotsSides
                }
                Rectangle {
                    color: "white"
                    width: settings.menudotsSides
                    height: settings.menudotsSides
                }
                Rectangle {
                    color: "white"
                    width: settings.menudotsSides
                    height: settings.menudotsSides
                }
            }
        }
    }
}
