import QtQuick 2.3
import QtQuick.Controls 1.2
import QtQuick.Layouts 1.1

RowLayout {
    visible: tunearea.currentTune !== null
    property int capoPosition: 0
    function setCapoPosition(pos) {
        if (capoPosition === pos)
            capoPosition = 0
        else
            capoPosition = pos
        score.markDirty(score.canvasWindow);
        switch (capoPosition) {
            case 0:
                capoimage.source = "capo0.png";
                break;
            case 1:
                capoimage.source = "capo1.png";
                break;
            case 2:
                capoimage.source = "capo2.png";
                break;
            case 3:
                capoimage.source = "capo3.png";
                break;
            case 4:
                capoimage.source = "capo4.png";
                break;
            case 5:
                capoimage.source = "capo5.png";
                break;
            case 6:
                capoimage.source = "capo6.png";
                break;
            case 7:
                capoimage.source = "capo7.png";
                break;
        }
    }
    Rectangle {
        id: fret1
        width: 20 * settings.fretscale
        height: 20 * settings.fretscale
        property int fret: 1
        color: capoPosition === fret ? "green" : "red"
        MouseArea {
            anchors.fill: parent
            onClicked: {
                setCapoPosition(fret1.fret);
            }
        }
    }
    Rectangle {
        id: fret2
        width: 20 * settings.fretscale
        height: 20 * settings.fretscale
        property int fret: 2
        color: capoPosition === fret ? "green" : "blue"
        MouseArea {
            anchors.fill: parent
            onClicked: {
                setCapoPosition(fret2.fret);
            }
        }
    }
    Rectangle {
        id: fret3
        width: 20 * settings.fretscale
        height: 20 * settings.fretscale
        property int fret: 3
        color: capoPosition === fret ? "green" : "red"
        MouseArea {
            anchors.fill: parent
            onClicked: {
                setCapoPosition(fret3.fret);
            }
        }
    }
    Rectangle {
        id: fret4
        width: 20 * settings.fretscale
        height: 20 * settings.fretscale
        property int fret: 4
        color: capoPosition === fret ? "green" : "blue"
        MouseArea {
            anchors.fill: parent
            onClicked: {
                setCapoPosition(fret4.fret);
            }
        }
    }
    Rectangle {
        id: fret5
        width: 20 * settings.fretscale
        height: 20 * settings.fretscale
        property int fret: 5
        color: capoPosition === fret ? "green" : "red"
        MouseArea {
            anchors.fill: parent
            onClicked: {
                setCapoPosition(fret5.fret);
            }
        }
    }
    Rectangle {
        id: fret6
        width: 20 * settings.fretscale
        height: 20 * settings.fretscale
        property int fret: 6
        color: capoPosition === fret ? "green" : "blue"
        MouseArea {
            anchors.fill: parent
            onClicked: {
                setCapoPosition(fret6.fret);
            }
        }
    }
    Rectangle {
        id: fret7
        width: 20 * settings.fretscale
        height: 20 * settings.fretscale
        property int fret: 7
        color: capoPosition === fret ? "green" : "red"
        MouseArea {
            anchors.fill: parent
            onClicked: {
                setCapoPosition(fret7.fret);
            }
        }
    }
    Rectangle {
        // guitar images
        width: 80.5 * settings.fretscale
        height: 20 * settings.fretscale
        Image {
            id: capoimage
            anchors.fill: parent
            source: "capo0.png"
        }
    }
    Text {
        visible: !noteTimer.paused      // need the space when all images are showing
        font.pixelSize: Math.floor(12 * settings.list_scale)
        text: "   Capo on fret " + capoPosition
        font.bold: capoPosition !== 0
    }
    Rectangle {
        opacity: 0
        Layout.fillWidth: true
        //width: 60 * settings.fretscale
        height: 20 * settings.fretscale
    }
    Rectangle {
        visible: settings.supportsAudio && noteTimer.paused
        //id: play
        width: 20 * settings.fretscale
        height: 20 * settings.fretscale
        Image {
            anchors.fill: parent
            source: "back.png"
        }
        MouseArea {
            anchors.fill: parent
            onClicked: {
                tunePlayer.previousBar();
            }
        }
    }
    Rectangle {
        visible: settings.supportsAudio && !noteTimer.running
        //id: play
        width: 20 * settings.fretscale
        height: 20 * settings.fretscale
        Image {
            anchors.fill: parent
            // from 'mobile' symbols in illustrator
            source: "play.png"
        }
        MouseArea {
            anchors.fill: parent
            onClicked: {
                if (noteTimer.paused)
                    tunePlayer.resume();
                else
                    tunePlayer.play();
            }
        }
    }
    Rectangle {
        visible: settings.supportsAudio && noteTimer.paused
        //id: play
        width: 20 * settings.fretscale
        height: 20 * settings.fretscale
        Image {
            anchors.fill: parent
            source: "forward.png"
        }
        MouseArea {
            anchors.fill: parent
            onClicked: {
                tunePlayer.nextBar();
            }
        }
    }
    Rectangle {
        visible: settings.supportsAudio && noteTimer.running
        //id: play
        width: 20 * settings.fretscale
        height: 20 * settings.fretscale
        Image {
            anchors.fill: parent
            source: "pause.png"
        }
        MouseArea {
            anchors.fill: parent
            onClicked: {
                tunePlayer.pause();
            }
        }
    }
    Rectangle {
        visible: settings.supportsAudio && (noteTimer.running || noteTimer.paused)
        //id: play
        width: 20 * settings.fretscale
        height: 20 * settings.fretscale
        Image {
            anchors.fill: parent
            source: "stop.png"
        }
        MouseArea {
            anchors.fill: parent
            onClicked: {
                tunePlayer.play();
            }
        }
    }

    Rectangle {
        visible: false  //settings.supportsAudio
        id: play
        width: 20 * settings.fretscale
        height: 20 * settings.fretscale
        color: noteTimer.running ? "red" : "green"
        Text {
            anchors.centerIn: parent
            font.pixelSize: Math.floor(12 * settings.list_scale)
            text: noteTimer.running ? "Stop" : "Play"
        }
        MouseArea {
            anchors.fill: parent
            onClicked: {
                tunePlayer.play();
            }
        }
    }
    Text {
        visible: settings.supportsAudio
        font.pixelSize: Math.floor(12 * settings.list_scale)
        text: "   Bar number: " + noteTimer.barNumber
    }
    Rectangle {
        visible: settings.supportsAudio
        opacity: 0
        width: 20 * settings.fretscale
        height: 20 * settings.fretscale
    }
    /*ToolBar {
        RowLayout {
            ToolButton {
                text: "previous melody instrument"
                onClicked: {
                    tunes.previousMelodyInstrument();
                }
            }
            ToolButton {
                text: "next melody instrument"
                onClicked: {
                    tunes.nextMelodyInstrument();
                }
            }
        }
    }
    ToolBar {
        RowLayout {
            ToolButton {
                text: "previous chord instrument"
                onClicked: {
                    tunes.previousChordInstrument();
                }
            }
            ToolButton {
                text: "next chord instrument"
                onClicked: {
                    tunes.nextChordInstrument();
                }
            }
        }
    }*/
}
