import QtQuick 2.3
import QtQuick.Controls 1.2
import QtQuick.Layouts 1.1

RowLayout {
    //Layout.preferredHeight: 50
    //height: 50
    spacing: 50
    Text {
        Layout.alignment: Qt.AlignLeft
        //id: addbooktext
        visible: booklistmodel.hasEditableItems && !bookentryform.visible
        text: library.editMode ? "Finish editing" : "Edit library..."
        font.pixelSize: Math.floor(16 * settings.list_scale)
        MouseArea {
            anchors.fill: parent
            onClicked: {
                bookentryform.visible = false;
                library.editMode = !library.editMode;
                confirmdeletion.cancel();
            }
        }
    }
    Text {
        Layout.alignment: Qt.AlignHCenter
        id: addbooktext
        visible: !bookentryform.visible
        text: "Add book Url..."
        font.pixelSize: Math.floor(16 * settings.list_scale)
        MouseArea {
            anchors.fill: parent
            onClicked: {
                bookentryform.clear();
                bookentryform.visible = true;
                library.editMode = false;
            }
        }
    }
    Text {
        Layout.alignment: Qt.AlignRight
        visible: !bookentryform.visible && settings.allowFilesToBeAdded
        text: "Add book file..."
        font.pixelSize: Math.floor(16 * settings.list_scale)
        MouseArea {
            anchors.fill: parent
            onClicked: {
                var i;
                bookentryform.clear();
                var toExclude = [];
                for (i = 0; i < booklistmodel.count; i++)
                {
                    var data = booklistmodel.get(i);
                    toExclude.push(data.book);
                }

                var files = library.createFileList(toExclude);
                booklistfilemodel.clear();
                for (i = 0; i < files.length; i++) {
                    booklistfilemodel.addFile(files[i])
                }
                filelist.currentIndex = -1;
                bookentryform.fileMode = true;
                bookentryform.visible = true;
                library.editMode = false;
            }
        }
    }
    Text {
        visible: settings.sharingEnabled
        Layout.alignment: Qt.AlignRight
        text: "Add shared urls"
        font.pixelSize: Math.floor(16 * settings.list_scale)
        MouseArea {
            anchors.fill: parent
            onClicked: {
                var files = library.getSharedLinks();
            }
        }
    }
}
