import QtQuick 2.3


Rectangle {
    id: imageandtextlink
    property string source
    property string text
    property var action
    property var pixelSize
    property var book;
    property var url;
    states: [
        State {
            name: "selected"
            PropertyChanges { target: imageandtextlink; color: "gray" }
        }
    ]
    function clear() {
        state = ""
    }
    //border.width: 2
    height:text.implicitHeight * 2
    width: height * 1.5 + text.implicitWidth
    radius: height / 10
    Row {
        Image {
            id: image
            width: imageandtextlink.height
            height: imageandtextlink.height
            source: imageandtextlink.source
        }
        Rectangle {
            width: image.width / 4
            height : imageandtextlink.height
            color: imageandtextlink.color
        }

        Text {
            id: text
            anchors.verticalCenter: image.verticalCenter
            font.pixelSize: imageandtextlink.pixelSize
            text: imageandtextlink.text
        }
    }
    MouseArea {
        anchors.fill: imageandtextlink
        cursorShape: Qt.PointingHandCursor
        onClicked: {
            imageandtextlink.state = "selected"
            action(book, url)
        }
    }
}
