import QtQuick 2.3
import QtQuick.Layouts 1.1

RowLayout {
    property string title
    property string book
    property string url
    function update() {
        download.visible = !library.isBookDownloaded(book);
        open.visible = library.isBookDownloaded(book);
        update.visible = library.isBookDownloaded(book);
    }

    Text {
        text: parent.title
    }
    Rectangle {
        id: download
        visible: !library.isBookDownloaded(parent.book)
        Layout.fillHeight: true
        color: "light gray"
        width: 100
        Text {
            anchors.centerIn: parent
            text: "Download"
        }
        MouseArea {
            anchors.fill: parent
            onClicked: {
                library.downloadBook(parent.parent.book, parent.parent.url)
            }
        }
    }
    Rectangle {
        id: open
        visible: library.isBookDownloaded(parent.book)
        Layout.fillHeight: true
        color: "light gray"
        width: 100
        Text {
            anchors.centerIn: parent
            text: "Open"
        }
        MouseArea {
            anchors.fill: parent
            onClicked: {
                booklist.visible = false;
                bookloader.bookname = parent.parent.book;
                bookloader.source = "TuneBook.qml"
            }
        }
    }
    Rectangle {
        id: update
        visible: library.isBookDownloaded(parent.book)
        Layout.fillHeight: true
        color: "light gray"
        width: 100
        Text {
            anchors.centerIn: parent
            text: "Update"
        }
        MouseArea {
            anchors.fill: parent
            onClicked: {
                library.downloadBook(parent.parent.book, parent.parent.url)
            }
        }
    }
}
