import QtQuick 2.3
import QtQuick.Controls 1.2
import QtQuick.Controls.Styles 1.2
import Tunes 1.0

Column {
    visible: tuneview.currentTune === null
    Row {
        id: loadMessageBox
        Text {
            font.pixelSize: Math.floor(12 * settings.text_scale)
            //text: "ABC file loaded OK, select a tune to display."
            text: {
                tunes.tunesItem !== null ?
                    tunes.tunesItem.resultText :
                     "Loading ABC file, please wait...";
            }
            //font.bold: true
        }
    }
    Row {
        id: successMessageBox
        Text {
            font.pixelSize: Math.floor(12 * settings.text_scale)
            text: {
                tunelist.count > 0 ?
                            "Select a tune from the tune list to be displayed..." : "";
            }
        }
    }
    Component {
        id: buttonStyle
        ButtonStyle {
            background: Rectangle {
                implicitWidth: 200
                implicitHeight: 100
                border.width: control.activeFocus ? 2 : 1
                border.color: "#888"
                radius: 4
                gradient: Gradient {
                    GradientStop { position: 0; color: control.pressed ? "#ccc" : "#eee" }
                    GradientStop { position: 1; color: control.pressed ? "#aaa" : "#ccc" }
                }
            }
        }
    }
    Button {
        //width: camerapanel.buttonWidth
        visible: tunes.tunesItem !== null && tunes.tunesItem.fileState === Tunes.NotFound
        text: qsTr("Download Paul Hardy's Session Tunebook")
        style: buttonStyle
        onClicked: {
            tunesLoader.item.downloadSessionBook();
        }
    }
}
