import QtQuick 2.3

Row {
    visible: tuneview.currentTune !== null && tuneview.currentTune.canPlay
    spacing: 10
    Text {
        text: {
            if (noteTimer.currentNote === null)
                ""
            else if (noteTimer.running)
                ""
            else
                "Previous bar"
        }
        MouseArea {
            anchors.fill: parent
            onClicked: {
                tunePlayer.previousBar();
            }
        }
    }
    Text {
        text: noteTimer.running ? "Stop" : "Play"
        MouseArea {
            anchors.fill: parent
            onClicked: {
                tunePlayer.play();
            }
        }
    }
    Text {
        text: {
            if (noteTimer.currentNote === null)
                ""
            else if (noteTimer.running)
                "Pause"
            else
                "Resume"
        }
        MouseArea {
            anchors.fill: parent
            onClicked: {
                tunePlayer.pause();
            }
        }
    }
    Text {
        text: {
            if (noteTimer.currentNote === null)
                ""
            else if (noteTimer.running)
                ""
            else
                "Next bar"
        }
        MouseArea {
            anchors.fill: parent
            onClicked: {
                tunePlayer.nextBar();
            }
        }
    }
    Text {
        visible: false
        //width: 200 * mainview.scale
        text: parent.currentTune === null ? "" : "Play 2"
        MouseArea {
            anchors.fill: parent
            onClicked: {
                parent.parent.currentTune.play();
            }
        }
    }
}
