import QtQuick 2.3
import QtQuick.Controls 1.2
import QtQuick.Controls.Styles 1.2
import QtQuick.Layouts 1.1

Item {
    property alias settingsmenu: settingsmenu
    Menu {
        id: repeatmenu
        MenuItem {
            text: "Playback repeat: 1"
            onTriggered: {
                tunes.tunesItem.repeatCount = 1
                tunes.saveSettings();
            }
        }
        MenuItem {
            text: "Playback repeat: 2"
            onTriggered: {
                tunes.tunesItem.repeatCount = 2
                tunes.saveSettings();
            }
        }
        MenuItem {
            text: "Playback repeat: 3"
            onTriggered: {
                tunes.tunesItem.repeatCount = 3
                tunes.saveSettings();
            }
        }
    }
    Menu {
        id: settingsmenu
        title: "Settings"
        Menu {
            title: {
                if (tunes.tunesItem.repeatCount === 1)
                    return "Play tune once..."
                else if (tunes.tunesItem.repeatCount === 2)
                    return "Play tune twice..."
                else
                    return "Repeat tune " + tunes.tunesItem.repeatCount + " times..."
            }
            visible: tunes.tunesItem != null
            MenuItem {
                checkable: true
                checked: tunes.tunesItem.repeatCount === 1
                visible: tunes.tunesItem != null
                text:  {
                    return "Play tune once"
                }
                onTriggered: {
                    tunes.tunesItem.repeatCount = 1
                    tunes.saveSettings();
                }
            }
            MenuItem {
                checkable: true
                checked: tunes.tunesItem.repeatCount === 2
                visible: tunes.tunesItem != null
                text:  {
                    return "Play tune twice"
                }
                onTriggered: {
                    tunes.tunesItem.repeatCount = 2
                    tunes.saveSettings();
                }
            }
            MenuItem {
                checkable: true
                checked: tunes.tunesItem.repeatCount === 3
                visible: tunes.tunesItem != null
                text:  {
                    return "Repeat tune 3 times"
                }
                onTriggered: {
                    tunes.tunesItem.repeatCount = 3
                    tunes.saveSettings();
                }
            }
        }
        //MenuSeparator { }
        Menu {
            title: {
                if (tunes.tunesItem.continuousPlay)
                    return "Continuous tune play..."
                else
                    return "Single tune play..."
            }
            visible: tunes.tunesItem != null
            MenuItem {
                checkable: true
                checked: tunes.tunesItem.continuousPlay === false
                visible: tunes.tunesItem != null
                text:  {
                    return "Play button will play selected tune"
                }
                onTriggered: {
                    tunes.tunesItem.continuousPlay = false;
                    tunes.saveSettings();
                }
            }
            MenuItem {
                checkable: true
                checked: tunes.tunesItem.continuousPlay === true
                visible: tunes.tunesItem != null
                text:  {
                    return "Play button will play all tunes in list"
                }
                onTriggered: {
                    tunes.tunesItem.continuousPlay = true;
                    tunes.saveSettings();
                }
            }
        }
        Menu {
            title: {
                return "Reverb: " + tunes.tunesItem.reverb + "..."
            }
            visible: Qt.platform.os === "android"
            MenuItem {
                checkable: true
                property string reverb: "No reverb"
                checked: tunes.tunesItem.reverb === reverb
                text:  reverb
                onTriggered: {
                    tunes.tunesItem.reverb = reverb;
                    tunes.saveSettings();
                }
            }
            MenuItem {
                checkable: true
                property string reverb: "Large hall"
                checked: tunes.tunesItem.reverb === reverb
                text:  reverb
                onTriggered: {
                    tunes.tunesItem.reverb = reverb;
                    tunes.saveSettings();
                }
            }
            MenuItem {
                checkable: true
                property string reverb: "Hall"
                checked: tunes.tunesItem.reverb === reverb
                text:  reverb
                onTriggered: {
                    tunes.tunesItem.reverb = reverb;
                    tunes.saveSettings();
                }
            }
            MenuItem {
                checkable: true
                property string reverb: "Chamber"
                checked: tunes.tunesItem.reverb === reverb
                text:  reverb
                onTriggered: {
                    tunes.tunesItem.reverb = reverb;
                    tunes.saveSettings();
                }
            }
            MenuItem {
                checkable: true
                property string reverb: "Room"
                checked: tunes.tunesItem.reverb === reverb
                text:  reverb
                onTriggered: {
                    tunes.tunesItem.reverb = reverb;
                    tunes.saveSettings();
                }
            }
        }
    }
}   // Item menu
