import QtQuick 2.3
import QtQuick.Controls 1.2
import QtQuick.Controls.Styles 1.2
import QtQuick.Layouts 1.1
import QtQuick.LocalStorage 2.0
import Tunes 1.0
//import TuneListModel 1.0
import RhythmModel 1.0
import AbcModel 1.0
import Tune 1.0
//import Bar 1.0
import AbcLine 1.0
import Note 1.0
import Tuplet 1.0
import InstrumentListModel 1.0
import TempoListModel 1.0
//import Settings 1.0
//import QtQuick.Window 2.1

Item {
    id: tunebook
//    width: mainview.width
//    height: mainview.height
//    Settings {
//        id: settings
//    }
    Behavior on width {

    }
    function keyPressed(event) {
    //Keys.onPressed: {
        if (event.key === Qt.Key_Left || event.key === Qt.Key_Up)
        {
            if (tunearea.currentTune)
            {
                tunearea.stopPlaying();
                tunes.setPreviousTune(tunearea);
            }
            event.accepted = true;
        }
        else if (event.key === Qt.Key_Right || event.key === Qt.Key_Down)
        {
            if (tunearea.currentTune)
            {
                tunearea.stopPlaying();
                tunes.setNextTune(tunearea);
            }
            event.accepted = true;
        }
    }
    TunesItem {
        id: tunes
    }

    function toggleShowLegs() {
        tunes.tunesItem.showLegs = !tunes.tunesItem.showLegs;
        tunes.saveSettings();
        tunearea.redrawScore(tunearea.currentTune);
    }

    function toggleHideStaffViewOnTab() {
        tunes.tunesItem.hideStaffWhenTab = !tunes.tunesItem.hideStaffWhenTab;
        tunes.saveSettings();
        tunearea.redrawScore(tunearea.currentTune);
    }

    function closeAllMenus() {
        rhythmsContainer.state = "";
        chordinstrumentsContainer.state = "";
        melodyinstrumentsContainer.state = "";
        tempolistContainer.state = "";
    }
    ThreeDotMenu {
        id: threedotsmenu
    }

    SlidingList {
        id: rhythmsContainer
        actionBarText: actionbar.actionbarRhythmsText
        model: tunes.tunesItem.getRhythmModel()
        index: 0    //instrumentlistmodel.getIndex(tunes.tunesItem.melodyInstrument);
        function action(index, name) {
            rhythmsContainer.index = index;
            tunes.populateTunesList(name);
            tunesTab.state = "";
        }
    }
    SlidingList {
        id: melodyinstrumentsContainer
        actionBarText: actionbar.actionbarMelodyText
        model: instrumentlistmodel
        index: instrumentlistmodel.getIndex(tunes.tunesItem.melodyInstrument);
        function action(index) {
            tunes.tunesItem.melodyInstrument = instrumentlistmodel.getNumberFromIndex(index);
        }
    }
    SlidingList {
        id: chordinstrumentsContainer
        actionBarText: actionbar.actionbarChordText
        model: instrumentlistmodel
        index: instrumentlistmodel.getIndex(tunes.tunesItem.chordInstrument);
        function action(index) {
            tunes.tunesItem.chordInstrument = instrumentlistmodel.getNumberFromIndex(index);
        }
    }
    SlidingList {
        id: tempolistContainer
        actionBarText: actionbar.actionbarTempoText
        model: tempolistmodel
        index: tunearea.currentTune === null ? 0 : tempolistmodel.getIndex(tunearea.currentTune.tempo);
        function action(index, name) {
            tunearea.currentTune.tempo = name;
        }
    }

    ActionBar {
        id: actionbar
    }
    RowLayout {
        anchors.top: actionbar.bottom
        width: parent.width
        height: parent.height - actionbar.height
        id: rowContainer
        x: 0
        spacing: 5
        ColumnLayout {
            id: tabview
            spacing: 5
            Layout.alignment: Qt.AlignCenter
            TabItem {
                id: tunesTab
                visible: tunelist.count > 0
                tabtext: "Hide Tunes"
                alttext: "Show Tunes"
                targetColumn: tuneColumn
                targetList: tunelist
                //stateController: tunelistdragger
            }
        }
        TempoListModel {
            id: tempolistmodel
        }

        InstrumentListModel {
            id: instrumentlistmodel
        }

        ListModel {
            id: abcLinesListModel
        }
        ListModel {
            id: abcLinesBarListModel
        }
        ListModel {
            id: noteListModel
        }


        ColumnLayout {
            id: tuneColumn
            Layout.alignment: Qt.AlignTop
            spacing: 5
            ListModel {
                id: tunesListModel
                // populated by call to tunes.populateTunesList()
            }
            /*ListHeader {
                id: tunelistdragger
                Layout.preferredWidth: width
                targetColumn: tuneColumn
                width: 200 * settings.list_scale
            }*/

            ListView {
                id: tunelist
                clip: true
                width: 200 * settings.list_scale
                property int minWidth: 200 * settings.list_scale
                property int initialWidth: 200 * settings.list_scale
                property real scale: 1.0
                flickableDirection: Flickable.HorizontalAndVerticalFlick
                onMovementEnded: {
                    if (contentX != 0) {
                        var newWidth = width  - contentX;
                        if (newWidth < minWidth) {
                            newWidth = minWidth;
                        }
                        width = newWidth;
                        scale = newWidth / initialWidth;
                        contentX = 0;
                    }
                }

                //height: mainview.height
                keyNavigationWraps: true
                currentIndex: -1
                //Layout.horizontalSizePolicy: Layout.Expanding
                Layout.preferredWidth: width
                Layout.alignment: Qt.AlignTop
                Layout.fillHeight: true
                highlightMoveDuration: 500
                Behavior on width {
                    PropertyAnimation {
                        id: tunelistAnimation
                        onStarted : {
                            // we always want to be visible when animating
                            if (!tunelist.visible)
                                tunelist.visible = true;
                        }
                        onStopped: {
                            if (tunelist.width === 0)
                                tunelist.visible = false;
                        }
                    }
                }
                //anchors.fill: parent
                //model: tunes.getTunesModel()
                model: tunesListModel
                highlight: Rectangle {
                    width: tunelist.width
                    //width: parent.width
                    color: "lightsteelblue"; radius: 5
                }
                focus: true
                delegate :
                    ColumnLayout {
                        spacing: 0
                        id: tunelisttextcolumn
                        property int largetextsize: 10   // was 12
                        property int smalltextsize: 8   // was 6
                        Layout.preferredWidth: parent.width
                        Text {
                            id: tunelisttext
                            width: tunelist.width
                            //font.pointSize: 10
                            font.pixelSize: Math.floor(largetextsize * settings.list_scale * tunelist.scale)
                            font.bold: true
                            //text: title // modelData
                            text: title
                        }
                        Text {
                            width: tunelist.width
                            font.pixelSize: Math.floor(smalltextsize * settings.list_scale * tunelist.scale)
                            text: subtitle1
                        }
                        RowLayout {
                            Layout.preferredWidth: tunelist.width
                            Text {
                                Layout.alignment: Qt.AlignLeft
                                font.pixelSize: Math.floor(smalltextsize * settings.list_scale * tunelist.scale)
                                text: subtitle2
                            }
                            Text {
                                Layout.alignment: Qt.AlignRight
                                font.pixelSize: Math.floor(smalltextsize * settings.list_scale * tunelist.scale)
                                text: rhythm + " " + meter + " " + key
                            }
                        }
                        Rectangle {
                            Layout.fillWidth: true
                            color: "gray"
                            //width: 200 * settings.list_scale
                            //width: tunelist.width   //50   //parent.width
                            height: 1
                        }
                        MouseArea {
                            anchors.fill: parent
                            onClicked: {
                                actionbar.searchInputFocus.focus = false;
                                tunearea.mergetext = "";
                                if (true)   //tunearea.currentTune == null)
                                    tunes.setCurrentTune(ref, tunearea)
                                else
                                    tunes.setCurrentTune(ref, tunearea1)
                                tunelist.currentIndex = index
                            }
                            onPressAndHold: {
                                actionbar.searchInputFocus.focus = false;
                                var i1 = index;
                                var i2 = tunelist.currentIndex;
                                //if (index !== tunelist.currentIndex) {
                                    //console.log("hold at: " + index);
                                    // add this to current tune
                                    tunearea.mergetext = tunearea.currentTune.mergeAbcs(ref);
                                    tunes.populateAbcLineList(tunearea.currentTune);
                                    tunearea.redrawScore(tunearea.currentTune);
                                    //tunes.updateAbc("", tunearea.currentTune)
                                //}
                            }
                        }
                    }
            }
        }
        Tuneview {
            id: tunearea
            Layout.fillWidth: true
            Layout.fillHeight: true
            Layout.alignment: Qt.AlignTop   //.AlignHCenter
        }
    }   // actionbar

    Rectangle {
        visible: tunes.tunesItem !== null && tunes.tunesItem.fileState === Tunes.NotFound
        anchors.fill: parent
        color: "light blue"
        Component {
            id: buttonStyle
            ButtonStyle {
                background: Rectangle {
                    implicitWidth: 200
                    implicitHeight: 100
                    border.width: control.activeFocus ? 2 : 1
                    border.color: "#888"
                    radius: 4
                    gradient: Gradient {
                        GradientStop { position: 0; color: control.pressed ? "#ccc" : "#eee" }
                        GradientStop { position: 1; color: control.pressed ? "#aaa" : "#ccc" }
                    }
                }
            }
        }
        ColumnLayout {
            anchors.centerIn: parent
            spacing: 100
            Button {
                //visible: false
                Layout.alignment: Qt.AlignCenter
                text: qsTr("Download Paul Hardy's Session Tunebook")
                style: buttonStyle
                onClicked: {
                    tunes.tunesItem.downloadSessionBook();
                }
            }
            Text {
                Layout.alignment: Qt.AlignCenter
                font.pixelSize: Math.floor(52 * settings.text_scale)
                //font.pixelSize: 52
                text: "Abc Session Viewer"
                color: "white"
            }
        }
        ColumnLayout {
            anchors.bottom: parent.bottom
            anchors.right: parent.right
            spacing: 10
            Text {
                Layout.alignment: Qt.AlignRight
                font.pixelSize: Math.floor(8 * settings.text_scale)
                //font.pixelSize: 16
                text: "Copyright (c) 2013-2014 Crossware Associates.  All rights reserved."
                color: "white"
            }
            Text {
                Layout.alignment: Qt.AlignRight
                font.pixelSize: Math.floor(8 * settings.text_scale)
                //font.pixelSize: 16
                text: "Crossware is a registered trademark of Crossware Associates."
                color: "white"
            }
        }
    }
}
