import QtQuick 2.3
import QtQuick.Controls 1.2
import QtQuick.Controls.Styles 1.2
import QtQuick.Layouts 1.1
import QtQuick.LocalStorage 2.0
import Tunes 1.0
import RhythmModel 1.0
import AbcModel 1.0
import Tune 1.0
import AbcLine 1.0
import Note 1.0
import Tuplet 1.0
import InstrumentListModel 1.0
import TempoListModel 1.0

Item
{
    //property Tunes tunes: null
    //property string resultText: "Loading ABC file, please wait...";
    property alias tunesItem: tunesLoader.item
    property string book: "pgh_session_tunebook"
    Loader {
        id: tunesLoader
        sourceComponent: tunesComponent
        asynchronous: true
        onLoaded: {
            item.load(bookloader.bookname);
            tunes.book = bookloader.shortbookname;
            //tunes.resultText = tunesLoader.item.loadText;
            //tunes.populateTunesList("All");
            tunes.loadSettings();
            actionbar.favourites.loadGroup(tunes.book);
            actionbar.session.loadGroup(tunes.book);
        }
    }
    /*Binding {
        target: tunesLoader.item
        property: fileState
        when: tunesLoader.item !== null
        onPropertyChanged: {
            if (tunesLoader.item.fileState === Tunes.Found) {
                tunes.populateTunesList("All");
            }
        }
    }*/

    Component {
        id: tunesComponent
        Tunes {
            onFileStateChanged: {
                if (tunesLoader.item.fileState === Tunes.Loaded) {
                    tunes.populateTunesList("All");
                }

            }
        }
    }

    //Tunes

    Component.onCompleted: {
        //setPath("/sdcard/Download/pgh_session_tunebook.abc");
        //setPath("C:\\Users\\Alan\\Documents\\pgh_session_tunebook.abc");
//            tunes = createTunesObject();
//            tunes.load();
//            resultText = tunes.loadText;
//            populateTunesList("All");
    }


    function saveSettings() {
        var db = LocalStorage.openDatabaseSync("AbcSessionViewerSettings", "1.0", "Abc Session Viewer Settings", 200);
        db.transaction(
            function(tx) {
                tx.executeSql('CREATE TABLE IF NOT EXISTS Settings(setting TEXT, value TEXT)');
                tx.executeSql('DELETE FROM Settings WHERE setting = ?', [ 'repeatCount' ]);
                tx.executeSql('DELETE FROM Settings WHERE setting = ?', [ 'continuousPlay' ]);
                tx.executeSql('DELETE FROM Settings WHERE setting = ?', [ 'showLegs' ]);
                tx.executeSql('DELETE FROM Settings WHERE setting = ?', [ 'hideStaffWhenTab' ]);
                tx.executeSql('DELETE FROM Settings WHERE setting = ?', [ 'reverb' ]);
                tx.executeSql('INSERT INTO Settings VALUES(?, ?)', [ 'repeatCount', tunesLoader.item.repeatCount]);
                tx.executeSql('INSERT INTO Settings VALUES(?, ?)', [ 'continuousPlay', tunesLoader.item.continuousPlay]);
                tx.executeSql('INSERT INTO Settings VALUES(?, ?)', [ 'showLegs', tunesLoader.item.showLegs]);
                tx.executeSql('INSERT INTO Settings VALUES(?, ?)', [ 'hideStaffWhenTab', tunesLoader.item.hideStaffWhenTab]);
                tx.executeSql('INSERT INTO Settings VALUES(?, ?)', [ 'reverb', tunesLoader.item.reverb]);
            }
        )
    }
    function loadSettings() {
        var db = LocalStorage.openDatabaseSync("AbcSessionViewerSettings", "1.0", "Abc Session Viewer Settings", 200);
        db.transaction(
            function(tx) {
                tx.executeSql('CREATE TABLE IF NOT EXISTS Settings(setting TEXT, value TEXT)');
                var rs = tx.executeSql('SELECT * FROM Settings');
                //var r = "";
                for (var i = 0; i < rs.rows.length; i++)
                {
                    //r += rs.rows.item(i).setting + rs.rows.item(i).value
                    if (rs.rows.item(i).setting === "repeatCount")
                        tunesLoader.item.repeatCount = rs.rows.item(i).value;
                    else if (rs.rows.item(i).setting === "continuousPlay")
                        tunesLoader.item.continuousPlay = rs.rows.item(i).value === "1";
                    else if (rs.rows.item(i).setting === "showLegs")
                        tunesLoader.item.showLegs = rs.rows.item(i).value === "1";
                    else if (rs.rows.item(i).setting === "hideStaffWhenTab")
                        tunesLoader.item.hideStaffWhenTab = rs.rows.item(i).value === "1";
                    else if (rs.rows.item(i).setting === "reverb")
                        tunesLoader.item.reverb = rs.rows.item(i).value;
                    //console.log(rs.rows.item(i).setting + ":" + rs.rows.item(i).value);
                }
            }
        )
    }

    function createTunesObject() {
        var tunesObject = Qt.createQmlObject('import QtQuick 2.0; import Tunes 1.0; Tunes {}', tunesItem, "dynamicTunes");
        return tunesObject;
    }

    function windowAreaChanged()
    {
        // console.log("windowAreadChaged")
        if (tunearea.currentTune !== null)
            tunearea.redrawScore(tunearea.currentTune);
    }
    function setNextTune(area)
    {
        var ref = area.currentTune.ref;
//            if (ref !== tunes.tunecollection[tunes.tunecollection.length - 1].ref)
        {
            // not if the last tune in the collection
            tunelist.incrementCurrentIndex();
            var item = tunesListModel.get(tunelist.currentIndex);
            if (item)
                ref = item.ref;
            {
                for (var i = 0; i < tunesLoader.item.tunecollection.length; i++)
                if (ref === tunesLoader.item.tunecollection[i].ref)
                {
                    //i++;
                    var tune = tunesLoader.item.tunecollection[i];
                    //area.currentTune = tunes.tunecollection[i];
                    populateAbcLineList(tune);
                    area.redrawScore(tune);
                    newCurrentTune();
                    //tunelist.currentIndex++;
                    break;
                }
            }
        }
    }
    function setPreviousTune(area)
    {
        var ref = area.currentTune.ref;
//          if (ref !== tunes.tunecollection[0].ref)
        {
            // not if the first tune in the collection
            tunelist.decrementCurrentIndex();
            var item = tunesListModel.get(tunelist.currentIndex);
            if (item)
                ref = item.ref;
            for (var i = 0; i < tunesLoader.item.tunecollection.length; i++)
            {
                if (ref === tunesLoader.item.tunecollection[i].ref)
                {
                    //i--;
                    var tune = tunesLoader.item.tunecollection[i];
                    //area.currentTune = tunes.tunecollection[i];
                    populateAbcLineList(tune);
                    area.redrawScore(tune);
                    newCurrentTune();
                    //tunelist.currentIndex--;
                    break;
                }
            }
        }
    }
    function setCurrentTune(ref, area)
    {
        for (var i = 0; i < tunesLoader.item.tunecollection.length; i++)
        {
            if (ref === tunesLoader.item.tunecollection[i].ref)
            {
                area.stopPlaying();
                var tune = tunesLoader.item.tunecollection[i];
                //area.currentTune = tunes.tunecollection[i];
                populateAbcLineList(tune);
                area.redrawScore(tune);
                newCurrentTune();
                break;
            }
        }
    }
    function newCurrentTune() {
        actionbar.favourites.updated();
        actionbar.session.updated();
    }

    //function getInstrumentModel() {
    //    return tunesLoader.item.getInstrumentModel();

    //}

    function updateAbc(text, tune) {
        abcLinesListModel.clear();
        abcLinesListModel.append({ "content" : text })
        tune.updateAbcFromText(text);
    }

    function revertAbc(tune) {
        tune.revertAbc();
        populateAbcLineList(tune);
    }

    function populateAbcLineText(tune) {
        var text = "",
                i;
        for (i = 0; i < tune.abclinecollection.length; i++)
        {
            text += tune.abclinecollection[i].content + "\n";
        }
        return text;
    }

    function populateAbcLineList(tune) {
        var i;
        abcLinesListModel.clear();
        for (i = 0; i < tune.abclinecollection.length; i++)
        {
            var test = tune.abclinecollection[i].content;
            abcLinesListModel.append({ "content" : tune.abclinecollection[i].content })
        }
        abcLinesBarListModel.clear();
        noteListModel.clear();
        for (i = 0; i < tune.abclinecollection.length; i++)
        {
            var s = "";
            var chords = "";
            for (var j = 0; j < tune.abclinecollection[i].bars.length; j++)
            {
                var bar = tune.abclinecollection[i].bars[j];
                s += bar.start;
                s += bar.content;
                s += bar.end;
                //abcLinesBarListModel.append({ "content" : currentTune.abclinecollection[i].bars[j].content })
                var countNotes = bar.notes.length;
                if (countNotes > 0)
                {
                    chords += bar.start;
                    for (var k = 0; k < bar.notes.length; k++)
                    {
                        var note = bar.notes[k];
                        if (note.hasChord)
                            chords += note.chordName;
                    }
                    chords += bar.end;
                }
            }
            noteListModel.append({ "content" : chords })
            abcLinesBarListModel.append({ "content" : s })
        }
        tempolistmodel.populate(tune.tempo);
    }

    function toggleChordSustain()
    {

    }

    function setInstrumentForMelody(number) {
        var tune = tunesLoader.item;
        tune.melodyInstrument = number;
    }
    function setInstrumentForChords(number) {
        var tune = tunesLoader.item;
        tune.chordInstrument = number;
    }

    function previousMelodyInstrument() {
        var tune = tunesLoader.item;
        tune.previousMelodyInstrument();
    }
    function nextMelodyInstrument() {
        var tune = tunesLoader.item;
        tune.nextMelodyInstrument();
    }
    function previousChordInstrument() {
        var tune = tunesLoader.item;
        tune.previousChordInstrument();
    }
    function nextChordInstrument() {
        var tune = tunesLoader.item;
        tune.nextChordInstrument();
    }

    property string selectedRhythm: "All"
    function isInGroup(groupname, title) {
        if (actionbar.favourites.isInOurGroup(groupname, title))
            return true;
        if (actionbar.session.isInOurGroup(groupname, title))
            return true;
        return false;
    }

    function populateTunesListFromSearch(text) {
        if (text === "")
            populateTunesList(selectedRhythm);
        else {
            var lowertext = text.toLowerCase();
            tunesListModel.clear();
            tunelist.currentIndex = -1;
            for (var i = 0; i < tunesLoader.item.tunecollection.length; i++) {
                var title = tunesLoader.item.tunecollection[i].title;
                var subtitle1 = tunesLoader.item.tunecollection[i].getTitle(1);
                var subtitle2 = tunesLoader.item.tunecollection[i].getTitle(2);
                var key = tunesLoader.item.tunecollection[i].key;
                var tunerhythm = tunesLoader.item.tunecollection[i].rhythm;
                var meter = tunesLoader.item.tunecollection[i].meter;
                if (title.toLowerCase().indexOf(lowertext) !== -1
                    || subtitle1.toLowerCase().indexOf(lowertext) !== -1
                    || subtitle2.toLowerCase().indexOf(lowertext) !== -1) {
                    tunesListModel.append({ "title" :  title, "subtitle1" : subtitle1, "subtitle2" : subtitle2, "key" : key, "rhythm" : tunerhythm, "meter" : meter, "ref" : tunesLoader.item.tunecollection[i].ref });
                }
            }
        }
    }

    function populateTunesList(rhythm) {
        selectedRhythm = rhythm;
        tunesListModel.clear();
        tunelist.currentIndex = -1;
        for (var i = 0; i < tunesLoader.item.tunecollection.length; i++) {
            var title = tunesLoader.item.tunecollection[i].title;
            // http://qt-project.org/wiki/How_to_create_columns_in_a_QML_ListView
            //var textElement = Qt.createQmlObject("import Qt 5.1; Text { text: " + title + "}");
            if (rhythm === "All" || isInGroup(rhythm, title) || rhythm === tunesLoader.item.tunecollection[i].rhythm) {
                var subtitle1 = tunesLoader.item.tunecollection[i].getTitle(1);
                var subtitle2 = tunesLoader.item.tunecollection[i].getTitle(2);
                var key = tunesLoader.item.tunecollection[i].key;
                var tunerhythm = tunesLoader.item.tunecollection[i].rhythm;
                var meter = tunesLoader.item.tunecollection[i].meter;
                tunesListModel.append({ "title" :  title, "subtitle1" : subtitle1, "subtitle2" : subtitle2, "key" : key, "rhythm" : tunerhythm, "meter" : meter, "ref" : tunesLoader.item.tunecollection[i].ref });
            }
        }
    }
}   // Item: tunes
